//+------------------------------------------------------------------+
//|                                                      Bimodal.mq4 |
//|                         Copyright 2018, Marius Ovidiu Sunzuiana. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, Marius Ovidiu Sunzuiana."
#property link      "https://www.mql5.com"
#property version   "1.777"

extern string StartHour="11:00";
extern string EndHour="20:00";

extern int  MagicNumber=777;
extern bool StandardMODE=true;
extern bool RandomMODE=false;
extern double takeprofit=0.0080;
extern double stoploss=0.0030;
extern double lot=0.01;
extern double Max_Floating_Loss_Currency=200;

int total=OrdersTotal();

#include <stdlib.mqh>
#include <stderror.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   MessageBox("Default is set to StandardMODE");
   if(Bars<100)
     {
      Print("Not enough bars for EA to trade");
      return(0);
     }
   Calculatedigits(Symbol());
   Comment("BIMODAL BALANCE : "+AccountBalance());
   if(IsDemo()==false)
     {
      Alert("Bimodal EA is set on live account");
     }
   else
     {
      Alert("Bimodal EA is set on demo account");
     }
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   int x;
   double floatingProfit=0;
   for(x=OrdersTotal()-1;x>=0;x--)
      if(OrderSelect(x,SELECT_BY_POS) && OrderMagicNumber()==MagicNumber)
         floatingProfit+=OrderProfit()+OrderCommission()+OrderSwap();
   if(floatingProfit<=-Max_Floating_Loss_Currency)
      for(x=OrdersTotal()-1;x>=0;x--)
         if(OrderSelect(x,SELECT_BY_POS) && OrderMagicNumber()==MagicNumber)
           {
            if(!OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),10,clrRed))
               Print("Error Closing Order #",OrderTicket(),". ",ErrorDescription(GetLastError()));
           }

   if(RandomMODE==true)
     {
      if(CalculateRandom()==0)
         OrderSend(Symbol(),OP_BUY,lot,Ask,4,(Ask-stoploss),(Ask+takeprofit),NULL,MagicNumber,0,clrDeepPink);
     }
   else if(StandardMODE==true)
     {
      double sar1;
      sar1=iSAR(Symbol(),0,0.02,0.2,0);
      if(Close[0]<sar1)
        {
         OrderSend(Symbol(),OP_BUY,lot,Ask,4,(Ask-stoploss),(Ask+takeprofit),NULL,MagicNumber,0,clrDeepPink);
        }
     }
  }
//+------------------------------------------------------------------+
int CalculateRandom()
  {
   MathSrand(GetTickCount());
   double random=MathRand()%2;
   return random;

  }
//+------------------------------------------------------------------+
double Calculatedigits(string currency)
  {
   int digits=MarketInfo(currency,MODE_DIGITS);
   if(digits==2 || digits==3)
      return 0.01;
   else if(digits==3 || digits==5)
      return 0.0001;
   return(Digits);
  }
//+------------------------------------------------------------------+
